; ml /c /coff NoImport.asm
; Link /subsystem:windows NoImport.com
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
.486
.model flat,stdcall
option casemap:none

include d:\masm32\include\windows.inc
include d:\masm32\include\kernel32.inc
include d:\masm32\include\user32.inc
include d:\masm32\include\masm32.inc
includelib d:\masm32\lib\user32.lib
includelib d:\masm32\lib\kernel32.lib
includelib d:\masm32\lib\masm32.lib


.data


;======== error handling:

error_stuff segment
ErrMsgTmpl db 'Error Code %i',13,10
      db 'Description: %s',0
      Unknown db 'UnKnownError',0
;szerror  db "error detected!",0
error_stuff ends

.code

GetErrDescription proc uses ebx edi ErrNum:DWORD

    LOCAL hLocal:DWORD
    LOCAL Buffer[256]:BYTE

    mov eax,ErrNum
    or eax,eax
    jne WeAlreadyKnowIt
    invoke GetLastError

    WeAlreadyKnowIt:
    mov edi,eax

    invoke FormatMessage,FORMAT_MESSAGE_ALLOCATE_BUFFER or \
                         FORMAT_MESSAGE_FROM_SYSTEM,
                         0,             ; GetItFromSystem
                         edi,0,         ; ErrNum,Default language
                         addr hLocal,   ; where to send the address of string from system
                         0,0            ; any size, no arguments

    or eax,eax
    mov ebx,offset UnKnown
    je UnKnown

    invoke LocalLock,hLocal

    mov ebx,eax

    UnKnown:

    invoke wsprintf,addr Buffer,offset ErrMsgTmpl,edi,ebx
    invoke MessageBox,0,addr Buffer,0,0
    cmp ebx,offset UnKnown
    je @F
    invoke LocalFree,hLocal
  @@:

    ret

GetErrDescription endp

end
